<?php
session_start();
function check_hmm($dir){
    $myfile=fopen($dir,r) or die("open failed!");
    $line=fgets($myfile);
    $error=0;
    if(strpos($line,"HMM")!=0){ 
       echo "Format error: not begins with 'HMMER';<br>";
       $error++;
}     
    
fseek($myfile,-1,SEEK_END);
$last= '';
while(($c = fgetc($myfile)) !== false)
{
  if($c == "\n" && $last) break;
  $last= $c . $last;
  fseek($myfile, -2, SEEK_CUR);
}  //get the last line to check 

  if(strpos($last,"//")===false)
{      echo "Format error: not ends with '//';<br>";
       $error++;
}    
       fclose($myfile);
       if($error==0)
          return true;
       else return false; 
}

function check_fasta($dir){
   $myfile      = fopen($dir,r) or die("open failed!");    //read only
   $error_count = 0;
   $num  = 0;   //num of ">"
   $last = 0;  //1 means the last line is a name_line , 0->a squence_line
   $line = fgets($myfile);   //the first line
   $line_num=1;
   if((strpos($line,">")===false)||(strpos($line,">")!=0)){ 
     echo "Error 1: not begins with a name_line;<br>&nbsp;&nbsp;&nbsp;Error location: line ".$line_num."<br> ";
     $error_count++;
     //regular expressions here  !!!
}
   else{ 
     $num++;
     $last=1;   //1 means the last line is a name_line , 0->a squence_line 
}  
     while(!feof($myfile)){    //begins from the next line
       $line=fgets($myfile);
       $line_num++;
       if(strpos($line,">")===false){ //could be squence_line 
            $last=0;  //last line is squence_line    
            //regular expressions here   !!!         
}
       else{  //could be a name_line 
           if($last==1){ //two neighbour name_line
               $error_count++;
               echo "Error ".$error_count." : two neighbour name_line;<br>&nbsp;&nbsp;&nbsp;Error location:  line ".($line_num-1)." and line ".$line_num."<br> ";
}
            else {
                  $num++;
                  $last=1;
           }//end of else 
     }//end of else 
}  //end of while
    fclose($myfile);
    if(($num<3)&&($error_count==0)){
         echo "not enough squences, you should  input at least 3 squences;<br>";
         return false;
}
       else if($error_count==0){
             echo $num."squences<br>";
             return true;
}
    fclose($myfile);
}   
function recurse_copy( $src, $dst )   // 原目录，复制到的目录
{
    $handle = opendir( $src );
    @mkdir( $dst );
    chmod($dst, 0777);
    while( false !== ( $file = readdir( $handle ) ) ) 
{
        if( ( $file != '.' ) && ( $file != '..' ) ) 
{
            if( is_dir( $src . '/' . $file ) )
{                                       
                recurse_copy( $src . '/' . $file, $dst . '/' . $file );
                chmod($src . '/' . $file, 0777);
                
            }
            else 
{
                copy( $src . '/' . $file, $dst . '/' . $file );
                chmod($dst . '/' . $file, 0777);
            }
        }
    }
    closedir( $handle );
}
function newfile(){
   $cip = $_SERVER["REMOTE_ADDR"];
   $num = 0;  
   $dir = "../".$cip.".".$num."/";
   $_SESSION['cip'] = $cip.".".$num;
   while(file_exists($dir))
   {
      $num++;
      $dir = "../".$cip.".".$num."/";
      $_SESSION['cip'] = $cip.".".$num;
   }    
    if (!mkdir($dir,0777)) 
       echo error_get_last()."<br />";
   chmod($dir,0777); 

   copy( '../exe/pHMM-Tree', $dir . 'pHMM-Tree' );
   chmod($dir . 'pHMM-Tree', 0777);
   copy( '../exe/prc', $dir . 'prc'  );
   chmod($dir . 'prc', 0777);
   copy( '../exe/usearch', $dir . 'usearch' );
   chmod($dir . 'usearch', 0777);
   recurse_copy("../source",$dir);
   ignore_user_abort (true);
   set_time_limit (0);
}

function deldir($dir) {
  //先删除目录下的文件：
  $dh=opendir($dir);
  while ($file=readdir($dh)) {
    if($file!="." && $file!="..") {
      $fullpath=$dir."/".$file;
      if(!is_dir($fullpath)) {
          unlink($fullpath);
      } else {
          deldir($fullpath);
      }
    }
  }
  closedir($dh);

  //删除当前文件夹：
  if(rmdir($dir)) {
    return true;
  } else {
    return false;
  }
}
function deletedir($dir) {

  //先删除目录下的文件：
  $dh=opendir($dir);
  while ($file=readdir($dh)) {
    if($file!="." && $file!="..") {
      $fullpath=$dir."/".$file;
      if(!is_dir($fullpath)&&($file!="result.zip")) {
          unlink($fullpath);
      }else {
         if(($file=="jQuery")||($file=="uploaded")||($file=="css")||($file=="images")||($file=="js"))
         {       
            echo $fullpath."<br>";
            deletedir($fullpath); 
            rmdir($fullpath);
         }                 
      }
    }
  }
  closedir($dh);
}
  
function data_process($type,$arg){
   $cip   = $_SESSION['cip'];
   $email = $_SESSION['email'];
   $mode  = $_SESSION['mode'];
   //echo "<br><label><span> user: ".$cip."</span ><br>";
   if(!empty($arg)){
      $name = $_SESSION['file-name'];
      $cmd = "/usr/bin/php5 ./cpp.php ".$type." ".$mode." ".$cip." ".$email." ".$arg." ".$name."> /dev/null &";
      exec($cmd); 
      echo "<br><span > upload correct!</span ><br>";
      echo "<br><span > Since the running time is too long, we will send the results by email to you later...</span ></label><br>";
   }else{
       $cmd = "/usr/bin/php5 ./cpp.php ".$type." ".$mode." ".$cip." ".$email." > /dev/null &";
       exec($cmd); 
       echo "<br><span > upload correct!</span ><br>";
       echo "<br><span > We will send the results to your mailbox later...</span ><br>";
    }
}

function cluster($dir){	
	$handle=opendir($dir); 
        $i = 1;
    if($handle){ 
        while (false !== ($file = readdir($handle))) { 
             
            if($file!="." && $file!='..'){ 
                               if($i==1)                             
				echo "<li class=\"nLi on\">";
                               else
                                echo "<li class=\"nLi\">";
				echo "<h3>".$file."</h3>";
				echo "<ul class=\"sub\">";																			 					 
                            $src    = $dir."/".$file;
			    $myfile = fopen($src,r) or die("open failed!");    //read only
                                while(!feof($myfile)){
					$line = fgets($myfile);
					if(strpos($line,'>')!==false){
					    echo "<li><a href=\"\">".$line."</a></li>";
					}
				}
				echo "</ul>";
				echo "</li>"; 
             $i++;
            }                                          
        } //end while
    } //end if
           
    else{
		return false;
	}	    
}  

?>
