<!DOCTYPE HTML>
<html>
<head>
<title>pHMM-Tree </title>
<link href="css/bootstrap.css" rel='stylesheet' type='text/css' />
<style>
ul { list-style-type: none;}
li { display: inline-block;}
li { margin: 10px 0;}
input.labelauty + label { font: 12px "Microsoft Yahei";}
</style>
<link rel="stylesheet" href="css/font-awesome.min.css" />
<script src="js/jquery.min.js"></script>
<script type="text/javascript" src="js/uploadJs.js"></script>
<link href="css/style.css" rel='stylesheet' type='text/css' />
<meta name="viewport" content="width=device-width, initial-scale=1">
<link href="css/font.css" rel='stylesheet' type='text/css'>
<script src="js/jquery-1.8.3.min.js"></script>
<script src="js/fenye.js"></script>
<link rel="stylesheet" href="css/jquery-labelauty.css" type='text/css'>	
</head>
<body>
<?php include_once("analyticstracking.php") ?>
<div  class="logo"><img src="images/logo.jpg" class="img-responsive" alt=""/></div>
<div class="header">
  <div class="container">
    <div class="logo"> <a href="index.php"><!--img src="images/" alt="Nova"--></a> </div>
    <div class="menu"> <a class="toggleMenu" href="#"> </a>
      <ul class="nav" id="nav">
        <li><a href="index.php">Home</a></li>		
        <li><a href="submit.php">Submit</a></li>
        <li><a href="download.html">Download</a></li>
		<li><a href="CAZyme.php">CAZyme</a></li>
		<li class="current"><a href="Pfam.php">Pfam</a></li>		
		<li><a href="help.html">Manual</a></li>
        <div class="clear"></div>
      </ul>
      <script type="text/javascript" src="js/responsive-nav.js"></script> 
    </div>
    <div class="clearfix"> </div>
  </div>
</div>

<div class="container">
    <label>APPLICATION ON PFAM CLANS</label><br>
    <div style="text-align: justify;">
		<p> The most recent Pfam release (30.0) contains 16,306 families (<a href="http://pfam.xfam.org/" style=" color: blue;">http://pfam.xfam.org/</a>). Among these families, 5,423 (33.3%) families are assigned to 595 clans.
		Among these clans, 254 (42.7%) clans have 5 or more families and 20 have over 40 families.<p>
	</div><br>
    <div style="text-align: justify;">
		<p> According to (Finn, et al., 2016), the graphical representation of clans with over 40 members has been a challenge. The most recent Pfam
		release attempted to address the issue using a new JavaScript clanviewer (Finn, et al., 2016) to present the families of a clan.
		Our experience is that such a network-like flash animated graph still does not work for well those large clans. With pHMM-tree, 
		we have built phylogenies for the 254 clans with at least 5 families. All the trees could be viewed in our website.
		In the following, we selected two example clans to show the phylogenies. <p>
	</div><br>
     <div class="row">
	    <div class="col-xs-2" >
		</div>
            <div class="col-xs-8" >
                 <table id="mytable" class="table table-hover">
                 <!--caption><label>Pfam</label></caption-->

                 <?php
                    include './excel.php';
                    $dir="../Excel/Pfam.xls";
                    table_Pfam($dir);
                   ?>
        
                 </table> 
                  <input id="pageSize" type="text" size="1" maxlength="2" value="getDefaultValue()" style="display:none;"/> 
                  <a href="#" id="pageSizeSet"></a>             
                  <a  id="sjzl"></a> &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
                  <a  href="#" id="btn1" style='color: blue'>FIRST </a>&nbsp&nbsp&nbsp&nbsp
                  <a href="#" id="btn2" style='color: blue'><<</a>&nbsp&nbsp&nbsp&nbsp
                  <a id="btn0" ></a>&nbsp&nbsp
                  <a  href="#" id="btn3" style='color: blue'>>></a>&nbsp&nbsp&nbsp&nbsp
                  <a  href="#" id="btn4" style='color: blue'>END </a> &nbsp&nbsp&nbsp&nbsp&nbsp&nbsp
                  <a>JumpTo </a>&nbsp&nbsp
                  <input id="changePage" type="text" size="1" maxlength="4"/>
                  <a>Page</a>&nbsp&nbsp
                  <a  href="#" id="btn5" style='color: blue'>JUMP</a>                

	     </div>
            <div class="col-xs-2" >
		</div>
    </div><br>  
     <div style="text-align: justify;">
		<p>		   		
		The first example is the Pfam clan Glutaminase_I (<a style='color: blue' href="http://pfam.xfam.org/clan/CL0014#tabview=tab3">CL0014</a>), which has 14 families. <label>Figure S7 </label>shows two representations of the family
		relationship of the clan. The left is the clanviewer network graph, with circles representing families and edges representing their relationships.
		The size of each circle represents the size of the family and the width of the edge represents the similarity between two families. 
		The graph can be dragged to rearrange the layout and can be zoomed in or out. The right side of the figure shows the pHMM phylogeny, 
		which is a more classic way for presenting evolutionary relationship of different entities, such as species, genes, and here protein families. 
		The two representations both present two major groups of families, but the phylogeny is clearly much easier to understand and interpret. 
		By nature, it also presents the relationship among different families in a hierarchical way. In addition, all families are included rather than
		left out in the graph. For example, the DUF4159 family is not connected to any other families in the network graph, but is clustered with its closest
		relative ThuA family in the phylogeny graph. <p>
	</div><br>
	 <div class="row">
	    <div class="col-xs-3" >
		</div>
        <div class="col-xs-6" >
		<img src="images/figure7.png" class="img-responsive" alt=""/>
		<label style="text-align: justify;">Figure S7: Pfam clanviewer network graph (left, copied from the Pfam website) and pHMM phylogeny (right) of the clan Glutaminase_I (CL0014). This clan was used in (Finn, et al., 2016) to introduce the new representation of clan relationship (the detailed explanation about the graph is the Figure of the paper). </label>
		
		</div>
		<div class="col-xs-3" >
		</div>
	</div><br>
	<div style="text-align: justify;">
		<p>The second example is the largest Pfam clan <a style='color: blue' href="http://pfam.xfam.org/clan/CL0123#tabview=tab3">CL0123 (Helix-turn-helix or HTH)</a>, which contains 254 families. As shown in Figure S8, the network
		graph is not possible to visualize in a global view as there are too many nodes and edges stacked on top of each other. Although clanviewer allows
		one to interactively view the graph (i.e., zoom in/out or move nodes by dragging), we believe the classic phylogenetic tree is much easier to view 
		to capture the relationship among such as large number of families. As an example, we highlighted the 27 DUF (domain of unknown function) families 
		in red in the phylogeny. One can quickly locate these families in the phylogeny and identify their closest neighbors.</p>
	</div><br>
	
    <div class="row">
	    <div class="col-xs-3" >
		</div>
        <div class="col-xs-6" >
		<img src="images/Figure8.png" class="img-responsive" alt=""/>
		<label style="text-align: justify;">Figure S8: Pfam clanviewer network graph (top, copied from the Pfam website) and pHMM phylogeny (bottom) of the clan HTH (CL0123). </label>
		</div>
		<div class="col-xs-3" >
		</div>
	</div>
	
</div>
<div class="footer_bottom">
       <div class="copy">
      <p>Contact yyin@niu.edu or zhanghan@nankai.edu.cn for questions. Copyright 2016 &copy NIU & NKU. All rights reserved.</p>

       </div>
</div>
</body>
</html>
