<?php
error_reporting(E_ALL);
 
date_default_timezone_set('Asia/ShangHai');
 
/** PHPExcel_IOFactory */
include_once '../Excel/PHPExcel.php';
include_once '../Excel/PHPExcel/IOFactory.php';
include_once '../Excel/PHPExcel/Reader/Excel5.php';
 
function table_dbCAN($filepath){
  
// Check prerequisites
if (!file_exists($filepath)) {
	exit("not found dbCAN.xls.\n");
}
 
$reader = PHPExcel_IOFactory::createReader('Excel5'); //设置以Excel5格式(Excel97-2003工作簿)
$PHPExcel = $reader->load($filepath); // 载入excel文件
$sheet = $PHPExcel->getSheet(0); // 读取第一個工作表
$highestRow = $sheet->getHighestRow(); // 取得总行数
$highestColumm = $sheet->getHighestColumn(); // 取得总列数
   
/** 循环读取每个单元格的数据 */
for ($row = 1; $row <= $highestRow; $row++){//行数是以第1行开始
    if($row==1){
        echo "<thead>";
	echo "<tr>";
	for ($column = 'A'; $column <= $highestColumm; $column++) {//列数是以A列开始
            $data = $sheet->getCell($column.$row)->getValue();   
            echo "<td>".$sheet->getCell($column.$row)->getValue()."</td>";
        }
	echo "</tr>";
	echo "</thead>"; 
    }
       
    else{
	if($row==2)
            echo "<tbody>";
	echo "<tr>";
        for ($column = 'A'; $column <= $highestColumm; $column++) {//列数是以A列开始
            if($column=='B'){$name=$sheet->getCell($column.$row)->getValue();}
            if($column=='A'){$class=$sheet->getCell($column.$row)->getValue();}
            $data = $sheet->getCell($column.$row)->getValue(); 
            if($column=='C'){
		echo "<td><a style='color: blue' href=\"http://www.cazy.org/".$name.".html\">".$data."</a></td>";
            }
            else{
		echo "<td><a style='color: blue' href=\"../testdata/dbCAN/hmm-tree/prc_hmms_mode_".$class."/neighbor_neighbor_outtree.pdf\">".$data."</a></td>";
	    }  
            
        }
	echo "</tr>";
    }            
}
echo "</tbody>";
}
function table_Pfam($filepath){
   
// Check prerequisites
if (!file_exists($filepath)) {
	exit("not found Pfam.xls.\n");
}
 
$reader = PHPExcel_IOFactory::createReader('Excel5'); //设置以Excel5格式(Excel97-2003工作簿)
$PHPExcel = $reader->load($filepath); // 载入excel文件
$sheet = $PHPExcel->getSheet(0); // 读取第一個工作表
$highestRow = $sheet->getHighestRow(); // 取得总行数
$highestColumm = $sheet->getHighestColumn(); // 取得总列数
   
/** 循环读取每个单元格的数据 */
for ($row = 1; $row <= $highestRow; $row++){//行数是以第1行开始
    if($row==1){
        echo "<thead>";
	echo "<tr>";
	for ($column = 'A'; $column <= $highestColumm; $column++) {//列数是以A列开始
            $data = $sheet->getCell($column.$row)->getValue();   
            echo "<td>".$sheet->getCell($column.$row)->getValue()."</td>";
        }
	echo "</tr>";
	echo "</thead>"; 
    }
       
    else{
	if($row==2)
            echo "<tbody>";
	echo "<tr>";
        for ($column = 'A'; $column <= $highestColumm; $column++) {//列数是以A列开始
            if($column=='B'){$name=$sheet->getCell($column.$row)->getValue();}
            if($column=='A'){$class=$sheet->getCell($column.$row)->getValue();}
            $data = $sheet->getCell($column.$row)->getValue(); 
            if($column=='C'){
		echo "<td><a style='color: blue' href=\"http://pfam.xfam.org/clan/".$name."\">".$data."</a></td>";
            }
            else{
		echo "<td><a style='color: blue' href=\"../testdata/Pfam/hmm-tree/prc_hmms_mode_".$class."/neighbor_neighbor_outtree.pdf\">".$data."</a></td>";
	    }  
            
        }
	echo "</tr>";
    }            
}
echo "</tbody>";
}
?>
