<!DOCTYPE HTML>
<html>
<head>
<title>pHMM-Tree </title>
<link href="css/bootstrap.css" rel='stylesheet' type='text/css' />
<link rel="stylesheet" href="css/font-awesome.min.css">
<script src="js/jquery.min.js"></script>
<link href="css/style.css" rel='stylesheet' type='text/css' />
<meta name="viewport" content="width=device-width, initial-scale=1">
<script type="application/x-javascript"> addEventListener("load", function() { setTimeout(hideURLbar, 0); }, false); function hideURLbar(){ window.scrollTo(0,1); } </script>
<link href="css/font.css" rel='stylesheet' type='text/css'>
</script>  
</head>
<body>
<?php include_once("analyticstracking.php") ?>
<div  class="logo"><img src="images/logo.jpg" class="img-responsive" alt=""/></div>
<div class="header">
  <div class="container">
    <div class="logo"> <a href="index.html"><!--img src="images/" alt="Nova"--></a> </div>
    <div class="menu"> <a class="toggleMenu" href="#"> </a>
      <ul class="nav" id="nav">
        <li class="current"><a href="index.php">Home</a></li>       
        <li><a href="submit.php">Submit</a></li>
        <li><a href="download.html">Download</a></li>
		<li><a href="CAZyme.php">CAZyme</a></li>
		<li><a href="Pfam.php">Pfam</a></li>		
		<li><a href="help.html">Manual</a></li>
        <div class="clear"></div>
      </ul>
      <script type="text/javascript" src="js/responsive-nav.js"></script> 
    </div>
    <div class="clearfix"> </div>
  </div>
</div>

<div class="main">
<!--div class="content_white">
  <h1>Welcome to pHMM-Tree Web Server!</h1>
  <p><p>
</div-->
<?php
/*
include './link.php';
$ip    = $_SERVER["REMOTE_ADDR"];
$time  = date("Y-m-d H:i:s");
$db_mysql   = new db_mysql();
$sql = "INSERT INTO visitor(visitor_ip,request_time) VALUES('$ip','$time')";
$db_mysql->execute_dql($sql);
$db_mysql->close_conn();*/
?>

<div class="container" style="height:480px;">
  
  <div class="testimonial">
    <div class="row testimonial_top">
      <div class="col-md-6">
        <ul class="test_box">
          <li class="test_img"><img src="images/nav_icon.png" class="img-responsive" alt=""/> </li>
          <li class="test_desc">
            <h4 style="color:black;font-weight:bold;font-style: italic; "><a href="#">What is pHMM-Tree?</a></h4>
            <p style="text-align: justify;">There are numerous softwares to build phylogenies of protein/DNA sequences. pHMM-Tree is the first software to generate a <b>phylogeny of profile hidden markov models (HMMs)</b>. 
			The algorithm behind pHMM-Tree is based on the profile-profile methods (Soding, 2005). It can be used to depict the evolutionary relationship of pHMMs (e.g. Pfam families of a clan or PANTHER subfamilies of a family).</p>
			
          </li>
          <div class="clearfix"> </div>
        </ul>
      </div>
      <div class="col-md-6">
        <ul class="test_box">
          <li class="test_img"><img src="images/nav_icon.png" class="img-responsive" alt=""/> </li>
          <li class="test_desc">
            <h4 style="font-weight:bold;font-style: italic; "><a href="#">How to run pHMM-Tree?</a></h4>
            <p style="text-align: justify;">pHMM-Tree was written in C/C++ language. It can flexibly handle four kinds of input: (1) multiple files each in pHMM format; (2) multiple files each with a multiple sequence alignment (MSA) in FASTA format; (3) mixture of 1 and 2; and (4) a file with unaligned protein sequences in FASTA format. <br><br><font color=red>Please cite <a href="https://www.ncbi.nlm.nih.gov/pubmed/28062446">Huo et al. Bioinformatics 2017</a> if you used our tool</font>.
			<!--span>Output of pHMM-Tree contains four files: (i)matrix file;(ii)tree data file;(iii)clusters files; (iv)HMM files.<span--> </p>
          </li>
          <div class="clearfix"> </div>
        </ul>
      </div>
    </div>
    <div class="row testimonial_bottom">
      <div class="col-md-6">
        <ul class="test_box">
          <li class="test_img"><img src="images/nav_icon.png" class="img-responsive" alt=""/> </li>
          <li class="test_desc">
            <h4 style="font-weight:bold;font-style: italic; "><a href="#">About us</a></h4>
            <p><a href="http://cys.bios.niu.edu" style="color:blue">Dr. Yanbin Yin's lab</a> at Northern Illinois University<br>
             <a href="http://cc.nankai.edu.cn/Teachers/Introduce.aspx?TID=zhangh" style="color:blue">Dr. Han Zhang's lab</a> at Nankai University </p>
          </li>
          <div class="clearfix"> </div>
        </ul>
      </div>
      <div class="col-md-6">
        <ul class="test_box">
          <li class="test_img"><img src="images/nav_icon.png" class="img-responsive" alt=""/> </li>
          <li class="test_desc">
            <h4 style="font-weight:bold;font-style: italic; "><a href="#">Tools that pHMM-Tree uses</a></h4>
            <p><a href="http://evolution.genetics.washington.edu/phylip/progs.data.dist.html" style="color:blue">Phylip</a>, <a href="http://hmmer.org/" style="color:blue">HMMER</a>,
              <a href="http://supfam.org/PRC/" style="color:blue">PRC</a>,
			   <a href="https://github.com/soedinglab/hh-suite" style="color:blue">hhsuite</a>, <a href="http://drive5.com/usearch/" style="color:blue">UCLUST</a>, <a href="http://mafft.cbrc.jp/alignment/software/" style="color:blue">MAFFT</a>.
            </p>
          </li>
          <div class="clearfix"> </div>
        </ul>
      </div>
    </div>
  </div>
</div>

  <div class="footer_bottom">
    <div class="copy">
      <p>Contact yyin@niu.edu or zhanghan@nankai.edu.cn for questions. Copyright 2016 &copy NIU & NKU. All rights reserved.</p>
    </div>
  </div>
</div>

</body>
</html>
